;RUNPROG II - no more kernel needed

;runprog.asm
;compiles to runprog.89z and runprog.9xz
;gives runprog() ASM on the calculator

;see README.TXT for compatibility information

;Can be run FROM A FUNCTION in all currently known AMS versions, but for AMS 2.0x see README.TXT.
;Usage: runprog("folder\program()") or runprog("program()") if the program is in the current folder

;Copyright (C) Kevin Kofler, 2000, 2001
;See README.TXT for license information

	include "OS.h"                ;Standard include file for _nostub programs.

        xdef _nostub                  ;No more kernel needed!
	xdef _main                    ;There is a main entry point. (This is not a library.)
	xdef _ti89                    ;This program works on a TI-89.
	xdef _ti92plus                ;This program works on a TI-92+ (why should it not? :-) ).

_main:                                ; AsmPrgm

	move.l a5,-(a7)               ;save a5
        move.l $c8,a5                 ;get pointer to the jump table
        move.l top_estack*4(a5),a1    ;get address of top_estack
	move.l (a1),a1                ; top_estack -> a1
	                              ;top_estack is a pointer to the end of the passed parameter.
	                              ;Now, a1 points to the char(0h2D) at the end of the string.
	subq.l #1,a1                  ; a1-1 -> a1
                                      ;Now, a1 points to the char(0h00) at the end of the string.
chk_again:                            ; Lbl chk_again
	                              ;Looking backwards for the next char(0h00).
	tst.b -(a1)                   ; a1-1 -> a1:If ord(character @ a1)/=0
	bne chk_again	              ; Goto chk_again
	                              ;Now, a1 points to the char(0h00) before the 1st character of the string.
	                              ;a1+1 points to the 1st character of the string.
	pea.l 1(a1)                   ;pass a1+1 as a parameter
        move.l push_parse_text*4(a5),a0  ;get address of push_parse_text
        jsr (a0)                      ;push_parse_text(a1)
        move.l HS_popEStack*4(a5),a0  ;get address of HS_popEStack
        jsr (a0)                      ; d0=HS_popEStack()
        move.w d0,(a7)                ;put d0 on the stack
        clr.w 2(a7)                   ;put FALSE on the stack
        move.l NG_execute*4(a5),a0    ;get address of NG_execute
        jsr (a0)                      ; NG_execute(d0,FALSE)
        move.l HeapFree*4(a5),a0      ;get address of HeapFree
        jsr (a0)                      ; HeapFree(d0)
;This is DIRTY! It assumes that NG_execute did not destroy the argument.
	addq.l #4,a7                  ;remove the arguments from the stack
	move.l (a7)+,a5               ;restore a5
	rts                           ; Return

	end                           ; EndPrgm
